public Action:Client_Challenge(client, args)
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	else
	{
		if (!g_bChallenge[client] && !g_bChallengeRequest[client])
		{
			if(IsPlayerAlive(client))
			{
				if (g_bNoBlock)
				{
					g_bMenuOpen[client]=true;
					new Handle:menu = CreateMenu(ChallengeMenuHandler1);
					SetMenuTitle(menu, "Challenge - Checkpoints?");
					AddMenuItem(menu, "Yes", "Yes");	
					AddMenuItem(menu, "No", "No");	
					SetMenuOptionFlags(menu, MENUFLAG_BUTTON_EXIT);
					DisplayMenu(menu, client, MENU_TIME_FOREVER);			
				}
				else
					PrintToChat(client, "%t", "ChallengeFailed1",RED,WHITE);
			}
			else
				PrintToChat(client, "%t", "ChallengeFailed2",RED,WHITE);
		}
		else
			PrintToChat(client, "%t", "ChallengeFailed3",RED,WHITE);
	}
	return Plugin_Handled;
}

public ChallengeMenuHandler1(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		decl String:info[32];
		GetMenuItem(menu, param2, info, sizeof(info));
		if(StrEqual(info,"Yes"))
			g_bCCheckpoints[param1]=true;
		else
			g_bCCheckpoints[param1]=false;
		new Handle:menu2 = CreateMenu(ChallengeMenuHandler2);
		g_bMenuOpen[param1]=true;
		decl String:tmp[64];
		Format(tmp, 64, "Challenge - Player Bet?\nYour Points: %i", g_pr_points[param1]);
		SetMenuTitle(menu2, tmp);		
		AddMenuItem(menu2, "0", "No bet");			
		Format(tmp, 64, "%i", g_pr_points_finished);
		if (g_pr_points_finished  <= g_pr_points[param1])
			AddMenuItem(menu2, tmp, tmp);	
		Format(tmp, 64, "%i", (g_pr_points_finished*2));
		if ((g_pr_points_finished*2)  <= g_pr_points[param1])
			AddMenuItem(menu2, tmp, tmp);		
		Format(tmp, 64, "%i", (g_pr_points_finished*3));
		if ((g_pr_points_finished*3)  <= g_pr_points[param1])
			AddMenuItem(menu2, tmp, tmp);		
		Format(tmp, 64, "%i", (g_pr_points_finished*8));
		if ((g_pr_points_finished*8)  <= g_pr_points[param1])
			AddMenuItem(menu2, tmp, tmp);		
		SetMenuOptionFlags(menu2, MENUFLAG_BUTTON_EXIT);
		DisplayMenu(menu2, param1, MENU_TIME_FOREVER);
	}
	else
	if(action == MenuAction_Cancel)
	{
		g_bMenuOpen[param1]=false;	
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

public ChallengeMenuHandler2(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		decl String:info[32];
		GetMenuItem(menu, param2, info, sizeof(info));
		new value = StringToInt(info);
		if (value == g_pr_points_finished)		
			g_CBet[param1] = 1;
		else
			if (value == (g_pr_points_finished*2))	
				g_CBet[param1] = 2;
			else
				if (value == (g_pr_points_finished*3))	
					g_CBet[param1] = 3;		
				else
					if (value == (g_pr_points_finished*8))	
						g_CBet[param1] = 8;		
					else
						g_CBet[param1] = 0;		
		decl String:szPlayerName[MAX_NAME_LENGTH];	
		new Handle:menu2 = CreateMenu(ChallengeMenuHandler3);
		SetMenuTitle(menu2, "Challenge - Select your Opponent");
		new playerCount=0;
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsValidEntity(i) && IsClientInGame(i) && IsPlayerAlive(i) && i != param1 )
			{
				GetClientName(i, szPlayerName, MAX_NAME_LENGTH);	
				AddMenuItem(menu2, szPlayerName, szPlayerName);	
				playerCount++;
			}
		}
		if (playerCount>0)
		{
			g_bMenuOpen[param1]=true;
			SetMenuOptionFlags(menu2, MENUFLAG_BUTTON_EXIT);
			DisplayMenu(menu2, param1, MENU_TIME_FOREVER);		
		}
		else
		{
			PrintToChat(param1, "%t", "ChallengeFailed4",MOSSGREEN,WHITE);
		}
		
	}
	else
	if(action == MenuAction_Cancel)
	{
		g_bMenuOpen[param1]=false;	
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

public ChallengeMenuHandler3(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		decl String:info[32];
		decl String:szPlayerName[MAX_NAME_LENGTH];
		decl String:szTargetName[MAX_NAME_LENGTH];
		GetClientName(param1, szPlayerName, MAX_NAME_LENGTH);
		GetMenuItem(menu, param2, info, sizeof(info));
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsValidEntity(i) && IsClientInGame(i) && IsPlayerAlive(i) && i != param1)
			{
				GetClientName(i, szTargetName, MAX_NAME_LENGTH);	
				
				if(StrEqual(info,szTargetName))
				{
					if (!g_bChallenge[i])
					{
						if ((g_pr_points_finished*g_CBet[param1]) <= g_pr_points[i])
						{
							g_CBet[i] = g_CBet[param1];
							g_bCCheckpoints[i] = g_bCCheckpoints[param1];
							decl String:szSteamId[32];
							GetClientAuthString(i, szSteamId, 32);	
							Format(g_szCOpponentID[param1], 32, szSteamId);	
							
							decl String:cp[16];
							if (g_bCCheckpoints[param1])
								Format(cp, 16, " allowed");
							else
								Format(cp, 16, " forbidden");
							new value = g_pr_points_finished * g_CBet[param1];
							PrintToChat(param1, "%t", "Challenge1", RED,WHITE, YELLOW, szTargetName, value,cp);
							PrintToChat(i, "%t", "Challenge2", RED,WHITE, YELLOW, szPlayerName, GREEN, WHITE, value,cp);
							g_fChallengeRequestTime[param1] = GetEngineTime();
							g_bChallengeRequest[param1]=true;
						}
						else
						{
							PrintToChat(param1, "%t", "ChallengeFailed5", RED,WHITE, szTargetName, g_pr_points[i]);
						}
					}
					else
						PrintToChat(param1, "%t", "ChallengeFailed6", RED,WHITE, szTargetName);
				}
			}
		}
	}
	else
	if(action == MenuAction_Cancel)
	{
		g_bMenuOpen[param1]=false;	
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

public Action:Client_Accept(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	decl String:szSteamId[32];
	GetClientAuthString(client, szSteamId, 32);		
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsValidEntity(i) && IsClientInGame(i) && IsPlayerAlive(i) && i != client && g_bChallengeRequest[i])
		{
			if(StrEqual(szSteamId,g_szCOpponentID[i]))
			{
				GetClientAuthString(i, g_szCOpponentID[client], 32);
				g_bChallengeRequest[i]=false;
				g_bChallenge[i]=true;
				g_bChallenge[client]=true;
				TeleportEntity(client, g_fCStartPosition[i],NULL_VECTOR,NULL_VECTOR);
				TeleportEntity(i, g_fCStartPosition[i],NULL_VECTOR,NULL_VECTOR);
				SetEntityMoveType(i, MOVETYPE_NONE);
				SetEntityMoveType(client, MOVETYPE_NONE);
				g_CountdownTime[i] = 10;
				g_CountdownTime[client] = 10;
				CreateTimer(1.0, Timer_Countdown, i, TIMER_REPEAT);
				CreateTimer(1.0, Timer_Countdown, client, TIMER_REPEAT);
				PrintToChat(client, "%t", "Challenge3",RED,WHITE, YELLOW);
				PrintToChat(i, "%t", "Challenge3",RED,WHITE, YELLOW);			
				decl String:szPlayer1[MAX_NAME_LENGTH];			
				decl String:szPlayer2[MAX_NAME_LENGTH];
				GetClientName(i, szPlayer1, MAX_NAME_LENGTH);
				GetClientName(client, szPlayer2, MAX_NAME_LENGTH);
				PrintToChatAll("[%cKZ%c] Challenge: %c%s%c vs. %c%s%c",RED,WHITE,MOSSGREEN,szPlayer1,WHITE,MOSSGREEN,szPlayer2,WHITE);
				CreateTimer(1.0, CheckChallenge, i, TIMER_REPEAT);
				CreateTimer(1.0, CheckChallenge, client, TIMER_REPEAT);
			}
		}
	}
	return Plugin_Handled;
}

public Action:Client_Surrender (client, args)
{
	decl String:szSteamIdOpponent[32];
	decl String:szNameOpponent[MAX_NAME_LENGTH];	
	decl String:szName[MAX_NAME_LENGTH];	
	if (!g_bPluginEnabled) return Plugin_Handled;
	if (g_bChallenge[client])
	{
		GetClientName(client, szName, MAX_NAME_LENGTH);
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && i != client)
			{	
				GetClientAuthString(i, szSteamIdOpponent, 32);		
				if (StrEqual(szSteamIdOpponent,g_szCOpponentID[client]))
				{
					GetClientName(i, szNameOpponent, MAX_NAME_LENGTH);	
					g_bChallenge[i]=false;
					g_bChallenge[client]=false;
					for (new j = 1; j <= MaxClients; j++)
					{
						if (1 <= j <= MaxClients && IsClientInGame(j) && IsValidEntity(j))
						{						
								PrintToChat(j, "%t", "Challenge4",RED,WHITE,MOSSGREEN,szNameOpponent, WHITE,MOSSGREEN,szName,WHITE);
						}
					}	
					if (g_CBet[client]>0)
					{
						g_pr_multiplier[client]-= g_CBet[client];
						g_pr_multiplier[i] += g_CBet[client];
						g_pr_showmsg[i] = true;
						g_pr_showmsg[client] = true;
						PrintToChat(i, "%t", "Rc_PlayerRankStart", MOSSGREEN,WHITE,GRAY);
						PrintToChat(client, "%t", "Rc_PlayerRankStart", MOSSGREEN,WHITE,GRAY);
						new lostpoints = g_CBet[client] * g_pr_points_finished;
							for (new j = 1; j <= MaxClients; j++)
								if (1 <= j <= MaxClients && IsClientInGame(j) && IsValidEntity(j))
									PrintToChat(j, "[%cKZ%c] %c%s%c has lost %c%i %cpoints!", MOSSGREEN, WHITE, PURPLE,szNameOpponent, GRAY, RED, lostpoints,GRAY);
						CreateTimer(4.0, RefreshPoints, i);
						CreateTimer(4.5, RefreshPoints, client);
						i = MaxClients+1;
					}
				}
			}
		}		
	}

	return Plugin_Handled;
}

public Action:Command_ext_Menu(client, const String:command[], argc)
{
	if (!g_bPluginEnabled) 
		return Plugin_Handled;
	g_bMenuOpen[client] = true;
	if (g_hclimbersmenu[client] != INVALID_HANDLE)
	{	
		g_hclimbersmenu[client] = INVALID_HANDLE;
	}
	if (g_bTeleMenuOpen[client])
		g_bTeleMenuwasOpen[client]=true;
	else
		g_bTeleMenuwasOpen[client]=false;
	g_bTeleMenuOpen[client] = false;	
	return Plugin_Handled;
}

public Action:Command_JoinTeam(client, const String:command[], argc) 
{ 
	if (!g_bPluginEnabled) 
		return Plugin_Handled;
	if (!client) return Plugin_Continue; 
	decl String:g_szTeam[4]; 
	GetCmdArgString(g_szTeam, sizeof(g_szTeam)); 
	new team = StringToInt(g_szTeam); 
	if (1 <= team <= 3) 
	{ 
		if(g_bSpectate[client])
		{
			if(g_fStartTime[client] != -1.0 && g_bTimeractivated[client] == true)
			{
				g_fPauseTime[client] = GetEngineTime() - g_fStartPauseTime[client];
			}
			g_bSpectate[client] = false;
		}	
		ChangeClientTeam(client, team); 
		return Plugin_Handled; 
    } 
    return Plugin_Continue; 
}  

public Action:Client_OptionMenu(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	OptionMenu(client);
	return Plugin_Handled;
}

public Action:Client_Next(client, args)
{
	//PrintToChat(client,"%b", g_bBhopPluginEnabled);
	//just debugging
	//new Float:StartCords[3];
	//StartCords[0] = -931.9;
	//StartCords[1] = 3855.8;
	//StartCords[2] = 16.0;
	//TeleportEntity(client, StartCords, NULL_VECTOR, NULL_VECTOR);
	//blue
	//CPrintToChatAll("test {blue} test {olive} test ({lightblue} test {orange} test {darkred} test {red} test {lightred} test");
	if (!g_bPluginEnabled) return Plugin_Handled;
	if(g_CurrentCp[client] == -1)
	{
		PrintToChat(client, "%t", "NoCheckpointsFound", MOSSGREEN,WHITE);
		return Plugin_Handled;
	}
	TeleClient(client,1);
	return Plugin_Handled;
}

public Action:NoClip(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	if (g_bMapFinished[client]==false)
	{
		if (!StrEqual(g_pr_rankname[client],"MASTER"))
		{
			PrintToChat(client, "%t", "NoclipNotAvailable2",MOSSGREEN, WHITE);
		}
		else
			if (g_bNoClip[client] == false)
				Action_NoClip(client);
	}
	else
		if (g_bNoClip[client] == false)
			Action_NoClip(client);	
	return Plugin_Handled;
}

public Action:UnNoClip(client, args)
{
	if (g_bNoClip[client] == true)
		Action_UnNoClip(client);
	return Plugin_Handled;
}

public Action:Client_Prev(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	if(g_CurrentCp[client] == -1)
	{
		PrintToChat(client, "%t", "NoCheckpointsFound", MOSSGREEN,WHITE);
		return Plugin_Handled;
	}
	TeleClient(client,-1);
	return Plugin_Handled;
}


public Action:Client_Save(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	SaveClientLocation(client)
	return Plugin_Handled;	
}

public Action:Client_Tele(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	TeleClient(client,0);
	return Plugin_Handled;
}

public Action:Client_Usp(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	GiveUsp(client);
	return Plugin_Handled;
}

public Action:Client_Top(client, args)
{	
	if (!g_bPluginEnabled) return Plugin_Handled;
	TopMenu(client);
	return Plugin_Handled;
}

public Action:Client_Kzmenu(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	if (!g_bAllowCheckpoints)
		PrintToChat(client, "%t", "CMenuDisabled",MOSSGREEN, WHITE);
	else
		TeleMenu(client);    
	return Plugin_Handled;
}

public ProfileMenu(client,args)
{
//declaration
	decl String:arg1[MAX_NAME_LENGTH];
	decl String:arg2[MAX_NAME_LENGTH];
	decl String:arg3[MAX_NAME_LENGTH];
	decl String:arg4[MAX_NAME_LENGTH];
	decl String:arg5[MAX_NAME_LENGTH];
	decl String:arg6[MAX_NAME_LENGTH];
	decl String:arg7[MAX_NAME_LENGTH];
	decl String:arg8[MAX_NAME_LENGTH];
	decl String:arg9[MAX_NAME_LENGTH];
	decl String:arg10[MAX_NAME_LENGTH];
	//no argument
	if (args == 0)
	{
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);		
		db_viewPlayerRank(client, szSteamId);
		return;
	}
	//get name
	else 
	if(args == 1)		
		GetCmdArg(1, g_szProfileName[client], MAX_NAME_LENGTH);	
	else 
	if(args == 2)
	{		
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s", arg1,arg2); 		
	}	
	else
	if(args == 3)
	{		
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);	
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s", arg1,arg2, arg3);
	}	
	else
	if(args == 4)
	{		
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);
		GetCmdArg(4, arg4, MAX_NAME_LENGTH);	
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s %s", arg1,arg2, arg3, arg4); 
	}	
	else
	if(args == 5)
	{	
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);
		GetCmdArg(4, arg4, MAX_NAME_LENGTH);
		GetCmdArg(5, arg5, MAX_NAME_LENGTH);	
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s %s %s", arg1,arg2, arg3, arg4, arg5); 
	}	
	else
	if(args == 6)
	{	
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);
		GetCmdArg(4, arg4, MAX_NAME_LENGTH);
		GetCmdArg(5, arg5, MAX_NAME_LENGTH);	
		GetCmdArg(6, arg6, MAX_NAME_LENGTH);	
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s %s %s %s", arg1,arg2, arg3, arg4, arg5, arg6); 
	}
	else
	if(args == 7)
	{	
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);
		GetCmdArg(4, arg4, MAX_NAME_LENGTH);
		GetCmdArg(5, arg5, MAX_NAME_LENGTH);	
		GetCmdArg(6, arg6, MAX_NAME_LENGTH);	
		GetCmdArg(7, arg7, MAX_NAME_LENGTH);	
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s %s %s %s %s", arg1,arg2, arg3, arg4, arg5, arg6, arg7); 
	}
	else
	if(args == 8)
	{	
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);
		GetCmdArg(4, arg4, MAX_NAME_LENGTH);
		GetCmdArg(5, arg5, MAX_NAME_LENGTH);	
		GetCmdArg(6, arg6, MAX_NAME_LENGTH);	
		GetCmdArg(7, arg7, MAX_NAME_LENGTH);	
		GetCmdArg(8, arg8, MAX_NAME_LENGTH);
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s %s %s %s %s %s", arg1,arg2, arg3, arg4, arg5, arg6, arg7, arg8); 
	}
	else
	if(args == 9)
	{	
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);
		GetCmdArg(4, arg4, MAX_NAME_LENGTH);
		GetCmdArg(5, arg5, MAX_NAME_LENGTH);	
		GetCmdArg(6, arg6, MAX_NAME_LENGTH);	
		GetCmdArg(7, arg7, MAX_NAME_LENGTH);	
		GetCmdArg(8, arg8, MAX_NAME_LENGTH);
		GetCmdArg(9, arg9, MAX_NAME_LENGTH);
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s %s %s %s %s %s %s", arg1,arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9); 
	}
	else
	if(args == 10)
	{	
		GetCmdArg(1, arg1, MAX_NAME_LENGTH);	
		GetCmdArg(2, arg2, MAX_NAME_LENGTH);	
		GetCmdArg(3, arg3, MAX_NAME_LENGTH);
		GetCmdArg(4, arg4, MAX_NAME_LENGTH);
		GetCmdArg(5, arg5, MAX_NAME_LENGTH);	
		GetCmdArg(6, arg6, MAX_NAME_LENGTH);	
		GetCmdArg(7, arg7, MAX_NAME_LENGTH);	
		GetCmdArg(8, arg8, MAX_NAME_LENGTH);
		GetCmdArg(9, arg9, MAX_NAME_LENGTH);
		GetCmdArg(10, arg10, MAX_NAME_LENGTH);	
		Format(g_szProfileName[client], MAX_NAME_LENGTH, "%s %s %s %s %s %s %s %s %s %s", arg1,arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10); 
	}	
	
	new bool:bPlayerFound=false;
	decl String:szSteamId2[32];
	decl String:szName[MAX_NAME_LENGTH];
			
	for (new i = 1; i <= MaxClients; i++)
	{
		if (1 <= i <= MaxClients && IsClientInGame(i))
		{
			GetClientName(i, szName, MAX_NAME_LENGTH);
			if(StrEqual(szName,g_szProfileName[client]))
			{
				bPlayerFound=true;
				GetClientAuthString(i, szSteamId2, 32);
				continue;
			}
		}
	}
	
	if (args != 0 && !StrEqual(g_szProfileName[client],"",false))
	{
		if (bPlayerFound)
			db_viewPlayerRank(client, szSteamId2);
		else
			db_viewPlayerAll(client, g_szProfileName[client]);
	}
}


public Action:Client_Hide(client, args) 
{ 	
	if (!g_bPluginEnabled) return Plugin_Handled;
	HideMethod(client)
	if (!g_bHide[client])
		PrintToChat(client, "%t", "Hide1",MOSSGREEN,WHITE); 
	else
		PrintToChat(client, "%t", "Hide2",MOSSGREEN,WHITE); 
    return Plugin_Handled; 
} 

public HideMethod(client)
{
	if (!g_bHide[client])
		g_bHide[client] = true; 
	else
		g_bHide[client] = false; 
}

public Action:Client_Showsettings(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	ShowSrvSettings(client);
	return Plugin_Handled;
}

public Action:Client_Help(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	HelpPanel(client);
	return Plugin_Handled;
}

public Action:Client_Profile(client, args)
{
	if (!g_bPluginEnabled) return Plugin_Handled;
	ProfileMenu(client,args);
	return Plugin_Handled;
}

public Action:Client_Start(client, args)
{
	if (!g_bPluginEnabled || !IsPlayerAlive(client) || GetClientTeam(client) == 1) 
		return Plugin_Handled;

	//spawn at Timer
	if (g_bRestartCords[client]==true)
		TeleportEntity(client, g_fPlayerCordsRestart[client],g_fPlayerAnglesRestart[client],NULL_VECTOR);		
	else //else spawn at spawnpoint
		CS_RespawnPlayer(client);	
	g_bPlayerJumped[client] = false;
	g_bNoClip[client] = false;
	return Plugin_Handled;	
}

public Action:Client_Pause(client, args) 
{
	if (g_bPluginEnabled==false  || GetClientTeam(client) == 1) return Plugin_Handled;
	PauseMethod(client);	
	if (g_bPause[client]==false)
		PrintToChat(client, "%t", "Pause2",MOSSGREEN, WHITE, RED, WHITE);
	else
		PrintToChat(client, "%t", "Pause3",MOSSGREEN, WHITE);
	return Plugin_Handled;
}

public PauseMethod(client)
{
	if (g_bPluginEnabled==false  || GetClientTeam(client) == 1) return;
	if (g_bPause[client]==false && IsValidEntity(client))
	{
		if (g_bPauseServerside==false) 
		{
			PrintToChat(client, "%t", "Pause1",MOSSGREEN, WHITE,RED,WHITE);
			return;
		}
		g_bPause[client]=true;
		SetEntityMoveType(client, MOVETYPE_NONE);
		//Timer enabled?
		if(g_bTimeractivated[client] == true)
		{
			g_fStartPauseTime[client] = GetEngineTime();
			if (g_fPauseTime[client] > 0.0)
				g_fStartPauseTime[client] = g_fStartPauseTime[client] - g_fPauseTime[client];	
		}
		SetEntityRenderMode(client, RENDER_NONE);
		SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
	}
	else
	{
		if(g_fStartTime[client] != -1.0 && g_bTimeractivated[client] == true)
		{
			g_fPauseTime[client] = GetEngineTime() - g_fStartPauseTime[client];
		}
		g_bPause[client]=false;
		SetEntityMoveType(client, MOVETYPE_WALK);
		SetEntityRenderMode(client, RENDER_NORMAL);
		if (g_bNoBlock)
			SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
		else
			SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 5, true);
	}
}

public Action:Client_CPMessage(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	CPMessage(client);
	if (g_bCPTextMessage[client] == true)
		PrintToChat(client, "%t", "CpMessage1",MOSSGREEN, WHITE);
	else
		PrintToChat(client, "%t", "CpMessage2",MOSSGREEN, WHITE);
	return Plugin_Handled;
}


public CPMessage(client)
{
	if (g_bCPTextMessage[client] == true)
		g_bCPTextMessage[client] = false;
	else
		g_bCPTextMessage[client] = true;
}

public Action:Client_Showtime(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	ShowTime(client)
	if (g_bShowTime[client] == true)
		PrintToChat(client, "%t", "Showtime1",MOSSGREEN, WHITE);
	else
		PrintToChat(client, "%t", "Showtime2",MOSSGREEN, WHITE);
	return Plugin_Handled;
}

public ShowTime(client)
{
	if (g_bShowTime[client] == true)
		g_bShowTime[client] = false;
	else
		g_bShowTime[client] = true;
}

public Action:Client_DisableGoTo(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	DisableGoTo(client);
	if (g_bGoToClient[client] == true)
		PrintToChat(client, "%t", "DisableGoto1",MOSSGREEN, WHITE);
	else
		PrintToChat(client, "%t", "DisableGoto2",MOSSGREEN, WHITE);
	return Plugin_Handled;
}


public DisableGoTo(client)
{
	if (g_bGoToClient[client] == true)
		g_bGoToClient[client]=false;
	else
		g_bGoToClient[client]=true;
}
	
public GoToMenuHandler(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		decl String:info[32];
		decl String:szPlayerName[MAX_NAME_LENGTH];
		GetMenuItem(menu, param2, info, sizeof(info));
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsValidEntity(i) && IsClientInGame(i) && IsPlayerAlive(i) && i != param1)
			{
				GetClientName(i, szPlayerName, MAX_NAME_LENGTH);	
				if(StrEqual(info,szPlayerName))
				{
					if (GetEntityFlags(i) & FL_ONGROUND)
					{
						new ducked = GetEntProp(i, Prop_Send, "m_bDucked");
						new ducking = GetEntProp(i, Prop_Send, "m_bDucking");
						if (!(GetClientButtons(param1) & IN_DUCK) && ducked == 0 && ducking == 0)
						{
							g_bPlayerJumped[param1] = false;
							new Float:position[3];
							new Float:angles[3];
							GetClientAbsOrigin(i,position);
							GetClientEyeAngles(i,angles);
							new Float:fVelocity[3];
							fVelocity[0] = 0.0;
							fVelocity[1] = 0.0;
							fVelocity[2] = 0.0;
							SetEntPropVector(param1, Prop_Data, "m_vecVelocity", fVelocity);
							TeleportEntity(param1, position,angles,fVelocity);
							decl String:szClientName[MAX_NAME_LENGTH];
							GetClientName(param1, szClientName, MAX_NAME_LENGTH);	
							PrintToChat(i, "%t", "Goto5", MOSSGREEN,WHITE, szClientName);
							continue;
						}
						else
						{
							PrintToChat(param1, "%t", "Goto6", MOSSGREEN,WHITE, szPlayerName);
							Client_GoTo(param1,0);
						}
					}
					else
					{
						PrintToChat(param1, "%t", "Goto7", MOSSGREEN,WHITE, szPlayerName);
						Client_GoTo(param1,0);
					}
				}
				else
				{
					if (i == MaxClients)
					{
						PrintToChat(param1, "%t", "Goto4", MOSSGREEN,WHITE, szPlayerName);
						Client_GoTo(param1,0);
					}
				}
			}
		}
	}
	else
	if(action == MenuAction_Cancel)
	{
		g_bMenuOpen[param1]=false;	
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}


public Action:Client_GoTo(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	if (g_bGoToServer==false)
		PrintToChat(client, "%t", "Goto1",MOSSGREEN,WHITE,RED,WHITE);
	else
	if (g_bNoBlock==false)
		PrintToChat(client, "%t", "Goto2",MOSSGREEN,WHITE);
	else
	if (g_bTimeractivated[client]==true)
		PrintToChat(client, "%t", "Goto3",MOSSGREEN,WHITE, RED);
	else
	{
		decl String:szPlayerName[MAX_NAME_LENGTH];	
		new Handle:menu = CreateMenu(GoToMenuHandler);
		SetMenuTitle(menu, "Go to Player");
		new playerCount=0;
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsValidEntity(i) && IsClientInGame(i) && IsPlayerAlive(i) && i != client ) //&& g_bGoToClient[i]
			{
				GetClientName(i, szPlayerName, MAX_NAME_LENGTH);	
				AddMenuItem(menu, szPlayerName, szPlayerName);	
				playerCount++;
			}
		}
		if (playerCount>0)
		{
			g_bMenuOpen[client]=true;
			SetMenuOptionFlags(menu, MENUFLAG_BUTTON_EXIT);
			DisplayMenu(menu, client, MENU_TIME_FOREVER);		
		}
		else
		{
			CloseHandle(menu);
			PrintToChat(client, "[%cKZ%c] No valid players found.",MOSSGREEN,WHITE);
		}
	}
	return Plugin_Handled;
}

public Action:Client_StrafeSync(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	StrafeSync(client);
	if (g_bStrafeSync[client] == true)
		PrintToChat(client, "%t", "StrafeSync1", MOSSGREEN,WHITE);
	else
		PrintToChat(client, "%t", "StrafeSync2", MOSSGREEN,WHITE);
	return Plugin_Handled;
}

public StrafeSync(client)
{
	if (g_bStrafeSync[client] == true)
		g_bStrafeSync[client] = false;
	else
		g_bStrafeSync[client] = true;
}

public Action:Client_ClimbersMenuSounds(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	ClimbersMenuSounds(client);
	if (g_bClimbersMenuSounds[client] == true)
		PrintToChat(client, "%t", "ClimbersMenuSounds1", MOSSGREEN,WHITE);
	else
		PrintToChat(client, "%t", "ClimbersMenuSounds2", MOSSGREEN,WHITE);
	return Plugin_Handled;
}

public ClimbersMenuSounds(client)
{
	if (g_bClimbersMenuSounds[client] == true)
		g_bClimbersMenuSounds[client] = false;
	else
		g_bClimbersMenuSounds[client] = true;
}
		
public Action:Client_QuakeSounds(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	QuakeSounds(client);
	if (g_bEnableQuakeSounds[client] == true)
		PrintToChat(client, "%t", "QuakeSounds1", MOSSGREEN,WHITE);
	else
		PrintToChat(client, "%t", "QuakeSounds2", MOSSGREEN,WHITE);
	return Plugin_Handled;
}

public QuakeSounds(client)
{
	if (g_bEnableQuakeSounds[client] == true)
		g_bEnableQuakeSounds[client] = false;
	else
		g_bEnableQuakeSounds[client] = true;
}
public Action:Client_Showkeys(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	Showkeys(client);
	if (g_bShowKeys[client] == true)
		PrintToChat(client, "%t", "ShowKeys1", MOSSGREEN,WHITE);
	else
		PrintToChat(client, "%t", "ShowKeys2", MOSSGREEN,WHITE);	
	return Plugin_Handled;
}

public Showkeys(client)
{
	if (g_bShowKeys[client] == true)
		g_bShowKeys[client] = false;
	else
		g_bShowKeys[client] = true;	
}
public Action:Client_Shownames(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	ShowNames(client);
	if (g_bShowNames[client] == true)
		PrintToChat(client, "%t", "ShowNames1", MOSSGREEN,WHITE);
	else
		PrintToChat(client, "%t", "ShowNames2", MOSSGREEN,WHITE);
	return Plugin_Handled;
}

public ShowNames(client)
{
	if (g_bShowNames[client] == true)
		g_bShowNames[client] = false;
	else
		g_bShowNames[client] = true;		
}

public Action:Client_Speed(client, args) 
{
	if (!g_bPluginEnabled) 
		return Plugin_Handled;
	SpeedMeter(client);	
	if (g_bSpeedMeter[client] == true)
		PrintToChat(client, "%t", "SpeedMeter1", MOSSGREEN,WHITE);
	else
		PrintToChat(client, "%t", "SpeedMeter2", MOSSGREEN,WHITE);
	return Plugin_Handled;
}

public SpeedMeter(client)
{
	if (g_bSpeedMeter[client] == true)
		g_bSpeedMeter[client] = false;
	else
	{
		if (IsPlayerAlive(client))
			g_bSpeedMeter[client] = true;
		else
			PrintToChat(client, "%t", "SpeedMeter3", MOSSGREEN,WHITE);
	}
}
public Action:Client_Colorchat(client, args) 
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	ColorChat(client);
	if (g_bColorChat[client] == true)
		PrintToChat(client, "%t", "Colorchat1", MOSSGREEN,WHITE);
	else
		PrintToChat(client, "%t", "Colorchat2", MOSSGREEN,WHITE);
	return Plugin_Handled;
}

public ColorChat(client)
{
	if (g_bColorChat[client] == true)
		g_bColorChat[client] = false;
	else
		g_bColorChat[client] = true;
}

public Action:Client_Stop(client, args)
{
	if(g_bPluginEnabled==false || !IsPlayerAlive(client) || GetClientTeam(client) == 1 || g_bPause[client])
		return Plugin_Handled;
	if (g_bTimeractivated[client] == true)
	{
		g_bTeleMenuOpen[client]=false;
		PlayerPanel(client);  //just to close kzmenu
		g_bTimeractivated[client] = false;
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);
		db_deleteTmp(client, szSteamId,g_szMapName);		
		g_fStartTime[client] = -1.0;
		g_fRunTime[client] = 0.0;		
		PrintToChat(client, "%t", "TimerStopped1", MOSSGREEN,WHITE,MOSSGREEN,WHITE);
	}
	return Plugin_Handled;
}

public Action:Client_lj(client, args)
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	db_selectTopLj(client);
	return Plugin_Handled;
}

public Action:Client_bhop(client, args)
{
	if (g_bPluginEnabled==false) return Plugin_Handled;
	db_selectTopBhop(client);
	return Plugin_Handled;
}

public SaveClientLocation(client)
{
	if (!g_bPluginEnabled || !IsPlayerAlive(client) || GetClientTeam(client) == 1) 
		return;
		
	if (!g_bCCheckpoints[client] && g_bChallenge[client])
	{
		PrintToChat(client, "[%cKZ%c] No checkpoints allowed during your challenge!", RED,WHITE);
		return;
	}

	
	//if player on ground
	if(GetEntDataEnt2(client, FindSendPropOffs("CBasePlayer", "m_hGroundEntity")) != -1)
	{
		if (CPLIMIT == g_CounterCp[client]) 
		{
			g_CurrentCp[client] = -1;
			g_CounterCp[client] = 0;
		}
		
		//save coordinates for new cp
		GetClientAbsOrigin(client,g_fPlayerCords[client][g_CounterCp[client]]);
		GetClientEyeAngles(client,g_fPlayerAngles[client][g_CounterCp[client]]);

		//increase counters
		g_CurrentCp[client] = g_CounterCp[client];
		g_CounterCp[client]++;
		g_OverallCp[client]++;		
		if (g_bClimbersMenuSounds[client] == true)
			EmitSoundToClient(client,"buttons/blip1.wav",client);
		if (g_bCPTextMessage[client]==true)
			PrintToChat(client, "%t", "CheckpointSaved", MOSSGREEN,WHITE,GRAY);
	}
	else
	{
		if (g_bClimbersMenuSounds[client]==true)
			EmitSoundToClient(client,"buttons/button10.wav",client);
		PrintToChat(client, "%t", "CheckpointsNotinAir", MOSSGREEN,WHITE,RED);
	}
}

public TeleClient(client,pos)
{
	if (g_bPluginEnabled==false || !IsPlayerAlive(client) || GetClientTeam(client) == 1 || g_CurrentCp[client] == -1) 
		return;
	if (g_bAllowCheckpoints == false)
	{
		PrintToChat(client, "%t", "CheckpointsDisabled", MOSSGREEN,WHITE);
		return;
	}
	new current = g_CurrentCp[client];
	new CounterCp = g_CounterCp[client];
	if (g_OverallCp[client] > CPLIMIT)
	{
		//if on last slot and next
		if(current == CPLIMIT-1 && pos == 1)
		{
			//reset to first
			g_CurrentCp[client] = -1;
			current = -1;
		}
		//if on first slot and previous
		if(current == 0  && pos == -1)
		{
			//reset to last
			g_CurrentCp[client] = CPLIMIT;
			current = CPLIMIT;
		}	
	}
	else
	{
		//if on last slot and next
		if(current == CounterCp-1 && pos == 1)
		{
			//reset to first
			g_CurrentCp[client] = -1;
			current = -1;
		}
		//if on first slot and previous
		if(current == 0  && pos == -1)
		{
			//reset to last
			g_CurrentCp[client] = CounterCp;
			current = CounterCp;
		}
	}
			
	new actual = current+pos;
	if(actual < 0 || actual > g_OverallCp[client])
		PrintToChat(client, "%t", "NoCheckpointsFound", MOSSGREEN,WHITE);
	else
	{ 
		g_bPlayerJumped[client] = false;
		g_strafecount[client] = 0;
		g_ground_frames[client] = 0;
		g_multi_bhop_count[client] = 1;
		g_OverallTp[client]++;
		new Float:fVelocity[3];
		fVelocity[0] = 0.0;
		fVelocity[1] = 0.0;
		fVelocity[2] = 0.0;
		SetEntPropVector(client, Prop_Data, "m_vecVelocity", fVelocity);
		TeleportEntity(client, g_fPlayerCords[client][actual],g_fPlayerAngles[client][actual],fVelocity);
		g_CurrentCp[client] += pos;
		if (g_bClimbersMenuSounds[client]==true)
			EmitSoundToClient(client,"buttons/blip1.wav",client);
	}		
}

public Action_NoClip(client)
{    
	if(client != 0 && IsClientInGame(client) && !IsFakeClient(client) && IsClientConnected(client) && IsPlayerAlive(client))
	{
		new team = GetClientTeam(client);
		if (team==2 || team==3)
		{
			new MoveType:mt = GetEntityMoveType(client);   
			if(mt == MOVETYPE_WALK)
			{
				if (g_bTimeractivated[client]==true)
				{
					g_bTimeractivated[client] = false;
					decl String:szSteamId[32];
					GetClientAuthString(client, szSteamId, 32);
					db_deleteTmp(client, szSteamId,g_szMapName);
					g_fStartTime[client] = -1.0;
					g_fRunTime[client] = 0.0;
				}				
				g_fLastTimeNoClipUsed[client] = GetEngineTime();
				SetEntityMoveType(client, MOVETYPE_NOCLIP);
				SetEntityRenderMode(client , RENDER_NONE); 
				SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
				g_bNoClip[client] = true;
			}
		}
	}
	return;
}  

public Action_UnNoClip(client)
{    
	if(client != 0 && IsClientInGame(client) && !IsFakeClient(client) && IsClientConnected(client) && IsPlayerAlive(client))
	{
		new team = GetClientTeam(client);
		if (team==2 || team==3)
		{
			new MoveType:mt = GetEntityMoveType(client);   
			if(mt == MOVETYPE_NOCLIP)
			{
				SetEntityMoveType(client, MOVETYPE_WALK);
				SetEntityRenderMode(client, RENDER_NORMAL);
				if(g_bNoBlock)
					SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 2, 4, true);
				else
					SetEntData(client, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), 5, 4, true);
				g_bNoClip[client] = false;
			}
		}
	}
	return;
}  

public GiveUsp(client)
{
	if(!IsPlayerAlive(client) || GetClientTeam(client) == 1 || g_bPluginEnabled == false)
		return;		
	GivePlayerItem(client, "weapon_usp_silencer");
	PrintToChat(client, "%t", "Usp1", MOSSGREEN,WHITE);
	PrintToChat(client, "%t", "Usp2", MOSSGREEN,WHITE);
}

public TeleMenu(client)
{
	if(!IsPlayerAlive(client) || GetClientTeam(client) == 1 || !g_bPluginEnabled || !g_bAllowCheckpoints)
	{
		g_bTeleMenuOpen[client] = false;
		return;
	}
	g_bTeleMenuOpen[client] = true;
	decl String:cp[32];
	decl String:title[128];
	decl String:tp[32];
	g_hclimbersmenu[client] = CreateMenu(TeleMenuHandler);
	if (g_bTimeractivated[client] == true)
	{
		GetcurrentRunTime(client);
		if (g_bPause[client])
			SetMenuTitle(g_hclimbersmenu[client], "Timer on hold");
		else
			SetMenuTitle(g_hclimbersmenu[client], g_szMenuTitleRun[client]);
		Format(cp, 32, "Checkpoint #%i", g_OverallCp[client]);
		Format(tp, 32, "Teleport #%i", g_OverallTp[client]);
		AddMenuItem(g_hclimbersmenu[client], "!save", cp);
		AddMenuItem(g_hclimbersmenu[client], "!tele", tp);
		if (g_bPause[client])
			AddMenuItem(g_hclimbersmenu[client], "!pause", "Pause - ON");
		else
			AddMenuItem(g_hclimbersmenu[client], "!pause", "Pause");
		AddMenuItem(g_hclimbersmenu[client], "!restart", "Start");
	}
	else
	{
		Format(title, 128, "%s\nClimbers Menu", g_szPlayerPanelText[client]);
		SetMenuTitle(g_hclimbersmenu[client], title);
		AddMenuItem(g_hclimbersmenu[client], "!save", "Checkpoint");
		AddMenuItem(g_hclimbersmenu[client], "!tele", "Gocheck");
		AddMenuItem(g_hclimbersmenu[client], "!restart", "Start");
		AddMenuItem(g_hclimbersmenu[client], "!Options", "Options");
	}
	SetMenuOptionFlags(g_hclimbersmenu[client], MENUFLAG_BUTTON_EXIT);
	DisplayMenu(g_hclimbersmenu[client], client, MENU_TIME_FOREVER);
}


public TeleMenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if (g_bTimeractivated[param1] == true)
		{
			switch(param2)
			{
				case 0: SaveClientLocation(param1);
				case 1: TeleClient(param1,0);
				case 2: PauseMethod(param1);
				case 3: Client_Start(param1, 0);
			}
		}
		else
		{
			switch(param2)
			{
				case 0: SaveClientLocation(param1);
				case 1: TeleClient(param1,0);
				case 2: Client_Start(param1, 0);
				case 3: OptionMenu(param1);
			}		
		}
		if (g_bTimeractivated[param1] == false && param2 == 3)
		{
		}
		else
			TeleMenu(param1);
	}	
	else
	if(action == MenuAction_Cancel)
	{
		if (param2 == -3)
			g_bTeleMenuOpen[param1]=false;
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

public TopMenu(client)
{
	if (g_bPluginEnabled==false) return;
	g_bTopMenuOpen[client]=true;
	g_bTeleMenuOpen[client]=false;
	new Handle:topmenu = CreateMenu(TopMenuHandler);
	SetMenuTitle(topmenu, "Top Menu");
	AddMenuItem(topmenu, "!topplayers", "Top 100 Players");
	AddMenuItem(topmenu, "Map Top", "Map Top");
	AddMenuItem(topmenu, "Jump Top", "Jump Top");
	SetMenuOptionFlags(topmenu, MENUFLAG_BUTTON_EXIT);
	DisplayMenu(topmenu, client, MENU_TIME_FOREVER);
}

public TopMenuHandler(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0: db_selectTopPlayers(param1);
			case 1: MapTopMenu(param1);
			case 2: JumpTopMenu(param1);
		}
	}
	else
	if(action == MenuAction_Cancel)
	{
		g_bTopMenuOpen[param1]=false;	
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

public MapTopMenu(client)
{
	if (g_bPluginEnabled==false) return;
	new Handle:topmenu2 = CreateMenu(MapTopMenuHandler);
	SetMenuTitle(topmenu2, "Map Top");
	if (!g_bMapButtons && g_BGlobalDBConnected && g_hDbGlobal != INVALID_HANDLE)
		AddMenuItem(topmenu2, "!globaltop", "Top 5 Global Times");
	AddMenuItem(topmenu2, "!topclimbers", "Top 50 Overall Times");
	AddMenuItem(topmenu2, "!proclimbers", "Top 20 Pro Times");
	AddMenuItem(topmenu2, "!cpclimbers", "Top 20 TP Times");
	SetMenuOptionFlags(topmenu2, MENUFLAG_BUTTON_EXIT);
	DisplayMenu(topmenu2, client, MENU_TIME_FOREVER);
}

public MapTopMenuHandler(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		if (!g_bMapButtons && g_BGlobalDBConnected && g_hDbGlobal != INVALID_HANDLE)
		{
			switch(param2)
			{
				case 0: db_selectGlobalTopClimbers(param1);
				case 1: db_selectTopClimbers(param1);
				case 2: db_selectProClimbers(param1);
				case 3: db_selectTPClimbers(param1);

			}
		}
		else
		{
			switch(param2)
			{
				case 0: db_selectTopClimbers(param1);
				case 1: db_selectProClimbers(param1);
				case 2: db_selectTPClimbers(param1);
			}		
		}

	}
	else
	if(action == MenuAction_Cancel)
	{
		TopMenu(param1);
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

public JumpTopMenu(client)
{
	if (g_bPluginEnabled==false) return;
	g_bTopMenuOpen[client]=true;
	g_bTeleMenuOpen[client]=false;
	new Handle:topmenu2 = CreateMenu(JumpTopMenuHandler);
	SetMenuTitle(topmenu2, "Jump Top");
	AddMenuItem(topmenu2, "!lj", "Top 20 Longjump");
	AddMenuItem(topmenu2, "!bhop", "Top 20 Bunnyhop");	
	AddMenuItem(topmenu2, "!multibhop", "Top 20 Multi-Bunnyhop");
	AddMenuItem(topmenu2, "!dropbhop", "Top 20 Drop-Bunnyhop");	
	AddMenuItem(topmenu2, "!wj", "Top 20 Weirdjump");
	SetMenuOptionFlags(topmenu2, MENUFLAG_BUTTON_EXIT);
	DisplayMenu(topmenu2, client, MENU_TIME_FOREVER);
}

public JumpTopMenuHandler(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{
			case 0: db_selectTopLj(param1);
			case 1: db_selectTopBhop(param1);
			case 2: db_selectTopMultiBhop(param1);
			case 3: db_selectTopDropBhop(param1);
			case 4: db_selectTopWj(param1);
		}
	}
	else
	if(action == MenuAction_Cancel)
	{
		TopMenu(param1);
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

public HelpPanel(client)
{
	if (g_bPluginEnabled==false) return;
	g_bMenuOpen[client] = true;
	g_bTeleMenuOpen[client]=false;
	new Handle:panel = CreatePanel();
	decl String:title[32];
	Format(title, 32, "KZMoD Help (1/3)");
	DrawPanelText(panel, title);
	DrawPanelText(panel, " ");
	DrawPanelText(panel, "!helpmenu - opens this menu");
	DrawPanelText(panel, "!menu - opens climbers menu");
	DrawPanelText(panel, "!options - opens options menu");
	DrawPanelText(panel, "!top - opens top menu");
	DrawPanelText(panel, "!profile - opens your profile menu (+ name for others)");
	DrawPanelText(panel, "!checkpoint / !gocheck - save location / teleport to location");
	DrawPanelText(panel, "!prev / !next - previous or next checkpoint");
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "next page");
	DrawPanelItem(panel, "exit");
	SendPanelToClient(panel, client, HelpPanelHandler, 10000);
	CloseHandle(panel);
}

public HelpPanelHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		if(param2==1)
			HelpPanel2(param1);
		else
		{
			g_bMenuOpen[param1] = false;
			TeleMenu(param1);		
		}
	}
}

public HelpPanel2(client)
{
	if (g_bPluginEnabled==false) return;
	new Handle:panel = CreatePanel();
	decl String:szTmp[64];
	Format(szTmp, 64, "KZMoD Help (2/3)");
	DrawPanelText(panel, szTmp);
	DrawPanelText(panel, " ")	
	DrawPanelText(panel, "!start - go back to start");
	DrawPanelText(panel, "!stop - stops the timer");
	DrawPanelText(panel, "!pause - on/off pause");
	DrawPanelText(panel, "!goto - opens Go-to menu");
	DrawPanelText(panel, "!usp - spawns a usp");
	DrawPanelText(panel, "!challenge - challenge a player");	
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "previous page");
	DrawPanelItem(panel, "next page");
	DrawPanelItem(panel, "exit");
	SendPanelToClient(panel, client, HelpPanel2Handler, 10000);
	CloseHandle(panel);
}
public HelpPanel2Handler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		if(param2==1)
			HelpPanel(param1);
		else
		if(param2==2)
			HelpPanel3(param1);
		else
		{
			TeleMenu(param1);
		}
	}
}

public HelpPanel3(client)
{
	if (g_bPluginEnabled==false) return;
	new Handle:panel = CreatePanel();
	decl String:szTmp[64];
	Format(szTmp, 64, "KZMoD Help (3/3)");
	DrawPanelText(panel, szTmp);
	DrawPanelText(panel, " ")
	DrawPanelText(panel, "!showsettings - show current KZmod settings");
	DrawPanelText(panel, " ")
	DrawPanelText(panel, "Binds:");
	Format(szTmp, 64, "Flashlight: bind KEY %cimpulse 100%c", QUOTE,QUOTE);
	DrawPanelText(panel, szTmp);	
	Format(szTmp, 64, "NoClip: bind KEY +noclip");
	DrawPanelText(panel, szTmp);	
	DrawPanelText(panel, " ");
	Format(szTmp, 64, "Skill groups: Novice (%ip), Scrub (%ip), Rookie (%ip),", g_pr_rank_Novice,g_pr_rank_Scrub,g_pr_rank_Rookie);
	DrawPanelText(panel, szTmp);
	Format(szTmp, 64, "Expert (%ip), Skilled (%ip), Pro (%ip), Elite (%ip),", g_pr_rank_Skilled,g_pr_rank_Expert,g_pr_rank_Pro,g_pr_rank_Elite);
	DrawPanelText(panel, szTmp);
	Format(szTmp, 64, "Master (%ip, NoClip unlocked)", g_pr_rank_Master);
	DrawPanelText(panel, szTmp);
	DrawPanelText(panel, " ");
	DrawPanelItem(panel, "previous page");
	DrawPanelItem(panel, "exit");
	SendPanelToClient(panel, client, HelpPanel3Handler, 10000);
	CloseHandle(panel);
}
public HelpPanel3Handler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		if(param2==1)
			HelpPanel2(param1);
		else
		{
			TeleMenu(param1);
		}
	}
}

public ShowSrvSettings(client)
{
	if (g_bPluginEnabled==false) return;
	PrintToConsole(client, " ");
	PrintToConsole(client, "---------------------");
	PrintToConsole(client, "KZMoD Server Settings");
	PrintToConsole(client, "---------------------");
	PrintToConsole(client, " ");
	PrintToConsole(client, "kz_auto_timer %i", g_bAutoTimer);
	PrintToConsole(client, "kz_autoheal %i", g_Autohealing_Hp);
	PrintToConsole(client, "kz_autorespawn %b", g_bAutoRespawn);
	PrintToConsole(client, "kz_checkpoints %b", g_bAllowCheckpoints);
	PrintToConsole(client, "kz_clean_weapons %b", g_bCleanWeapons);
	PrintToConsole(client, "kz_dist_min_lj %.1f", g_dist_good_lj);
	PrintToConsole(client, "kz_dist_pro_lj %.1f", g_dist_pro_lj);
	PrintToConsole(client, "kz_dist_leet_lj %.1f", g_dist_leet_lj);
	PrintToConsole(client, "kz_dist_min_bhop %.1f", g_dist_good_bhop);
	PrintToConsole(client, "kz_dist_pro_bhop %.1f", g_dist_pro_bhop);
	PrintToConsole(client, "kz_dist_leet_bhop %.1f", g_dist_leet_bhop);
	PrintToConsole(client, "kz_dist_min_multibhop %.1f", g_dist_good_multibhop);
	PrintToConsole(client, "kz_dist_pro_multibhop %.1f", g_dist_pro_multibhop);
	PrintToConsole(client, "kz_dist_leet_multibhop %.1f", g_dist_leet_multibhop);
	PrintToConsole(client, "kz_dist_min_dropbhop %.1f", g_dist_good_dropbhop);
	PrintToConsole(client, "kz_dist_pro_dropbhop %.1f", g_dist_pro_dropbhop);
	PrintToConsole(client, "kz_dist_leet_dropbhop %.1f", g_dist_leet_dropbhop);
	PrintToConsole(client, "kz_dist_min_wj %.1f", g_dist_good_weird);
	PrintToConsole(client, "kz_dist_pro_wj %.1f", g_dist_pro_weird);
	PrintToConsole(client, "kz_dist_leet_wj %.1f", g_dist_leet_weird);
	PrintToConsole(client, "kz_enabled %b", g_bPluginEnabled);
	PrintToConsole(client, "kz_godmode %b", g_bgodmode);
	PrintToConsole(client, "kz_goto %b", g_bGoToServer);
	PrintToConsole(client, "kz_prespeed_cap 380.0 (fixed)");
	PrintToConsole(client, "kz_prespeed_max_counted 300.0 (fixed)");
	PrintToConsole(client, "kz_noblock %b", g_bNoBlock);
	PrintToConsole(client, "kz_pause %b", g_bPauseServerside);
	PrintToConsole(client, "kz_point_system %b", g_bPointSystem);
	PrintToConsole(client, "kz_radio %b", g_bRadioCommands);
	PrintToConsole(client, "kz_restore %b", g_bRestore);
	PrintToConsole(client, "kz_settings_enforcer %b", g_bEnforcer);
	PrintToConsole(client, " ");
	PrintToChat(client, "[%cKZ%c] See console for output!", MOSSGREEN,WHITE);	
}

public OptionMenu(client)
{
	if (g_bPluginEnabled==false) return;
	g_bMenuOpen[client] = true;
	new Handle:optionmenu = CreateMenu(OptionMenuHandler);
	SetMenuTitle(optionmenu, "Options Menu");
	//1
	if (g_bSpeedMeter[client])
		AddMenuItem(optionmenu, "Speedmeter panel  -  Enabled", "Speedmeter panel  -  Enabled");
	else
		AddMenuItem(optionmenu, "Speedmeter panel  -  Disabled", "Speedmeter panel  -  Disabled");
	//2
	if (g_bColorChat[client])	
		AddMenuItem(optionmenu, "Color chat  -  Enabled", "Color chat  -  Enabled");
	else
		AddMenuItem(optionmenu, "Color chat  -  Disabled", "Color chat (except you)  -  Disabled");
	//3
	if (g_bCPTextMessage[client])
		AddMenuItem(optionmenu, "Checkpoint message  -  Enabled", "Checkpoint message  -  Enabled");
	else
		AddMenuItem(optionmenu, "Checkpoint message  -  Disabled", "Checkpoint message  -  Disabled");

	//4
	if (g_bEnableQuakeSounds[client])
		AddMenuItem(optionmenu, "Quake sounds - Enabled", "Quake sounds - Enabled");
	else
		AddMenuItem(optionmenu, "Quake sounds - Disabled", "Quake sounds - Disabled");

	//5
	if (g_bClimbersMenuSounds[client])
		AddMenuItem(optionmenu, "Clibmers menu sound  -  Enabled", "Climbers menu sounds  -  Enabled");
	else
		AddMenuItem(optionmenu, "Climbers menu sound  -  Disabled", "Climbers menu sounds -  Disabled");
	//6
	if (g_bHide[client])
		AddMenuItem(optionmenu, "Hide Players  -  Enabled", "Hide players  -  Enabled");
	else
		AddMenuItem(optionmenu, "Hide Players  -  Disabled", "Hide players  -  Disabled");			
	//7	
	if (g_bShowTime[client])
		AddMenuItem(optionmenu, "Timer Display  -  Enabled", "Timer panel  -  Enabled");
	else
		AddMenuItem(optionmenu, "Timer Display  -  Disabled", "Timer panel  -  Disabled");			
	//8
	if (g_bGoToClient[client])
		AddMenuItem(optionmenu, "Goto  -  Enabled", "Goto me  -  Enabled");
	else
		AddMenuItem(optionmenu, "Goto  -  Disabled", "Goto me  -  Disabled");		
	//9
	if (g_bShowKeys[client])
		AddMenuItem(optionmenu, "Spec Player Keys  -  Enabled", "Spec player keys  -  Enabled");
	else
		AddMenuItem(optionmenu, "Spec Player Keys  -  Disabled", "Spec player keys  -  Disabled");	
	//10
	if (g_bShowNames[client])
		AddMenuItem(optionmenu, "Player Name Panel  -  Enabled", "Player name panel  -  Enabled");
	else
		AddMenuItem(optionmenu, "Player Name Panel  -  Disabled", "Player name panel  -  Disabled");	
	//11
	if (g_bStrafeSync[client])
		AddMenuItem(optionmenu, "Strafe Sync  -  Enabled", "Strafe sync in chat  -  Enabled");
	else
		AddMenuItem(optionmenu, "Strafe Sync  -  Disabled", "Strafe sync in chat  -  Disabled");		
	SetMenuOptionFlags(optionmenu, MENUFLAG_BUTTON_EXIT);
	if (g_OptionMenuLastPage[client] < 6)
		DisplayMenuAtItem(optionmenu, client, 0, MENU_TIME_FOREVER);
	else
		DisplayMenuAtItem(optionmenu, client, 6, MENU_TIME_FOREVER);
	
}

public OptionMenuHandler(Handle:menu, MenuAction:action, param1,param2)
{
	if(action == MenuAction_Select)
	{
		switch(param2)
		{			
			case 0: SpeedMeter(param1);
			case 1: ColorChat(param1);
			case 2: CPMessage(param1);
			case 3: QuakeSounds(param1);
			case 4: ClimbersMenuSounds(param1);
			case 5: HideMethod(param1);
			case 6: ShowTime(param1);
			case 7: DisableGoTo(param1);
			case 8: Showkeys(param1);
			case 9: ShowNames(param1);
			case 10: StrafeSync(param1);
		}
		g_OptionMenuLastPage[param1] = param2;
		OptionMenu(param1);		
	}
	else
	if(action == MenuAction_Cancel)
	{
		if (param2!=9)
			g_bMenuOpen[param1]=false;	
	}
	else if (action == MenuAction_End)
	{	
		CloseHandle(menu);
	}
}

