
public Action:Admin_KzPanel(client, args)
{
	KzAdminMenu(client);
	return Plugin_Handled;
}

public KzAdminMenu(client)
{
	//if no valid player
	if(client == 0)
		return;
	g_bTeleMenuOpen[client] = false;
	g_bMenuOpen[client]=true;
		
	
	decl String:szTmp[64];
	new Handle:adminmenu = CreateMenu(AdminPanelHandler);
	SetMenuTitle(adminmenu, "KZMoD Admin Menu");
	if (g_bNoClip[client])
		Format(szTmp, sizeof(szTmp), "[1.] Admin noclip  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[1.] Admin noclip  -  Disabled");
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (MAX_PR_PLAYERS<g_pr_players || g_pr_players > 50000)
		AddMenuItem(adminmenu, "[2.] Recalculate player ratings", "[1.] Recalculate player ratings",ITEMDRAW_DISABLED);
	else
		AddMenuItem(adminmenu, "[2.] Recalculate player ratings", "[1.] Recalculate player ratings");
	AddMenuItem(adminmenu, "[3.] Set start button", "[2.] Set start button");
	AddMenuItem(adminmenu, "[4.] Set end button", "[3.] Set end button");
	AddMenuItem(adminmenu, "[5.] Delete map buttons", "[4.] Delete map buttons");
	if (g_bPluginEnabled)
		Format(szTmp, sizeof(szTmp), "[6.] KZMod  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[6.] KZMod  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (g_bEnforcer)
		Format(szTmp, sizeof(szTmp), "[7.] Settings enforcer  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[7.] Settings enforcer  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (g_bgodmode)
		Format(szTmp, sizeof(szTmp), "[8.] Godmode  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[8] Godmode  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (g_bAllowCheckpoints)
		Format(szTmp, sizeof(szTmp), "[9.] Checkpoints  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[9.] Checkpoints  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);	
	if (g_bNoBlock)
		Format(szTmp, sizeof(szTmp), "[10.] Noblock  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[10.] Noblock  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (g_bAutoRespawn)
		Format(szTmp, sizeof(szTmp), "[11.] Autorespawn  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[11.] Autorespawn  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (g_bCleanWeapons)
		Format(szTmp, sizeof(szTmp), "[12.] Clean weapons  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[12.] Clean weapons  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);	
	if (g_bRestore)
		Format(szTmp, sizeof(szTmp), "[13.] Restore function  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[13.] Restore function  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (g_bPauseServerside)
		Format(szTmp, sizeof(szTmp), "[14.] Pause function  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[14.] Pause function  -  Disabled"); 		
	AddMenuItem(adminmenu, szTmp, szTmp);
	if (g_bGoToServer)
		Format(szTmp, sizeof(szTmp), "[15.] !goto command  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[15.] !goto command  -  Disabled"); 
	AddMenuItem(adminmenu, szTmp, szTmp);	
	if (g_bRadioCommands)
		Format(szTmp, sizeof(szTmp), "[17.] Radio commands  -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[17.] Radio commands  -  Disabled"); 			
	AddMenuItem(adminmenu, szTmp, szTmp);	
	if (g_bAutoTimer)
		Format(szTmp, sizeof(szTmp), "[18.] Timer starts at spawn -  Enabled"); 	
	else
		Format(szTmp, sizeof(szTmp), "[18.] Timer starts at spawn  -  Disabled"); 						
	AddMenuItem(adminmenu, szTmp, szTmp);
	
	SetMenuExitButton(adminmenu, true);
	SetMenuOptionFlags(adminmenu, MENUFLAG_BUTTON_EXIT);
	
	
	if (g_AdminMenuLastPage[client] < 6)
	{
		DisplayMenuAtItem(adminmenu, client, 0, MENU_TIME_FOREVER);
	}
	else
		if (g_AdminMenuLastPage[client] < 12)
		{
			DisplayMenuAtItem(adminmenu, client, 6, MENU_TIME_FOREVER);	
		}
		else
			if (g_AdminMenuLastPage[client] < 18)
			{
				DisplayMenuAtItem(adminmenu, client, 12, MENU_TIME_FOREVER);	
			}
}


// thx to AL-KINDA
public AdminPanelHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		if (param2 == 0)
		{
			if (g_bNoClip[param1] == false)
				Action_NoClip(param1);
			else
				Action_UnNoClip(param1);
		}	
		if(param2 == 1)
		{ 
			if (g_pr_refreshingDB==false)
			{
				PrintToChat(param1, "%t", "PrUpdateStarted", MOSSGREEN,WHITE);
				g_bManualRecalc=true;
				g_bManualRecalcClientID=param1;
				RefreshPlayerRankTable();
			}
			else
			{
				PrintToChat(param1, "%t", "PrUpdateInProgress", MOSSGREEN,WHITE);
			}
		}
		if(param2 == 2)
		{ 
			SetStandingStartButton(param1);
		}
		if(param2 == 3)
		{ 
			SetStandingStopButton(param1);
		}
		if(param2 == 4)
		{ 
			DeleteButtons(param1);
			db_deleteMapButtons(g_szMapName);
			PrintToChat(param1,"[%cKZ%c] Timer buttons deleted", MOSSGREEN,WHITE,GREEN,WHITE);
		}
		if(param2 == 5)
		{
			if (g_bPluginEnabled==false)
			{
				ServerCommand("kz_enabled 1");
			}
			else
			{
				ServerCommand("kz_enabled 0");	
			}
		}
		if(param2 == 6)
		{
			if (g_bEnforcer==false)
			{
				ServerCommand("kz_settings_enforcer 1");
			}
			else
			{
				ServerCommand("kz_settings_enforcer 0");
			}
		}
		if(param2 == 7)
		{
		
			if (g_bgodmode==false)
			{
				ServerCommand("kz_godmode 1");
			}
			else
			{	
				ServerCommand("kz_godmode 0");
			}
		}		
		if(param2 == 8)
		{
			if (g_bAllowCheckpoints==false)
			{
				ServerCommand("kz_checkpoints 1");
			}
			else
			{
				ServerCommand("kz_checkpoints 0");
			}
		}		
		if(param2 == 9)
		{
			if (g_bNoBlock==false)
			{
				ServerCommand("kz_noblock 1");
			}
			else
			{
				ServerCommand("kz_noblock 0");
			}
		}		
		if(param2 == 10)
		{
			if (g_bAutoRespawn==false)
			{
				ServerCommand("kz_autorespawn 1");
			}
			else
			{
				ServerCommand("kz_autorespawn 0");
			}
		}					
		if(param2 == 11)
		{
			if (g_bCleanWeapons==false)
			{
				ServerCommand("kz_clean_weapons 1");
			}
			else
			{	
				ServerCommand("kz_clean_weapons 0");
			}
		}
		if(param2 == 12)
		{
			if (g_bRestore==false)
			{
				ServerCommand("kz_restore 1");
			}
			else
			{
				ServerCommand("kz_restore 0");
			}
		}
		if(param2 == 13)
		{
			if (g_bPauseServerside==false)
			{
				ServerCommand("kz_pause 1");
			}
			else
			{
				ServerCommand("kz_pause 0");
			}
		}
		if(param2 == 14)
		{
			if (g_bGoToServer==false)
			{
				ServerCommand("kz_goto 1");
			}
			else
			{
				ServerCommand("kz_goto 0");
			}
		}		
		if(param2 == 15)
		{
			if (g_bRadioCommands==false)
			{
				ServerCommand("kz_radio 1");
			}
			else
			{
				ServerCommand("kz_radio 0");
			}
		}
		if(param2 == 16)
		{
			if (g_bAutoTimer==false)
			{
				ServerCommand("kz_auto_timer 1");
			}
			else
			{
				ServerCommand("kz_auto_timer 0");
			}
		}			
		g_AdminMenuLastPage[param1]=param2;
		if (menu != INVALID_HANDLE)
			CloseHandle(menu);
		CreateTimer(0.1, RefreshAdminMenu, param1);
	}
				
	if(action == MenuAction_Cancel)
	{
		g_bMenuOpen[param1] = false;
	}
	if(action == MenuAction_End)
	{
		//test
		if (1 <= param1 <= MaxClients && IsClientInGame(param1))
		{
			g_bMenuOpen[param1] = false;
			if (menu != INVALID_HANDLE)
				CloseHandle(menu);
		}
	}
	
	
}

//Drop Map from DB
public Action:Admin_DropMap(client, args)
{
	db_dropMap(client);
	return Plugin_Handled;
}

public Action:Admin_DropPlayer(client, args)
{
	db_dropPlayer(client);
	return Plugin_Handled;
}

public Action:Admin_DropPlayerJump(client, args)
{
	db_dropPlayerJump(client);
	return Plugin_Handled;
}

public Action:Admin_ResetRecords(client, args)
{
	if(args < 1){
		ReplyToCommand(client, "[SM] Usage: sm_resetrecords <playername> [<mapname>]");
		return Plugin_Handled;
	}else if(args == 1){
		decl String:szPlayerName[MAX_NAME_LENGTH];
		GetCmdArg(1, szPlayerName, MAX_NAME_LENGTH);
		
		db_resetPlayerRecords(client, szPlayerName, g_szMapName);
	}else if(args == 2){
		decl String:szPlayerName[MAX_NAME_LENGTH];
		decl String:szMapName[MAX_MAP_LENGTH];
		GetCmdArg(1, szPlayerName, MAX_NAME_LENGTH);
		GetCmdArg(2, szMapName, MAX_NAME_LENGTH);	
		db_resetPlayerRecords(client, szPlayerName, szMapName);
	}
	return Plugin_Handled;
}

public Action:Admin_ResetLjRecords(client, args)
{
	if(args == 1)
	{
		decl String:szPlayerName[MAX_NAME_LENGTH];
		GetCmdArg(1, szPlayerName, MAX_NAME_LENGTH);		
		db_resetPlayerLjRecord(client, szPlayerName);
	}
	return Plugin_Handled;
}

public Action:Admin_ResetWjRecords(client, args)
{
	if(args == 1)
	{
		decl String:szPlayerName[MAX_NAME_LENGTH];
		GetCmdArg(1, szPlayerName, MAX_NAME_LENGTH);		
		db_resetPlayerWJRecord(client, szPlayerName);
	}
	return Plugin_Handled;
}

public Action:Admin_ResetDropBhopRecords(client, args)
{
	if(args == 1)
	{
		decl String:szPlayerName[MAX_NAME_LENGTH];
		GetCmdArg(1, szPlayerName, MAX_NAME_LENGTH);		
		db_resetPlayerDropBhopRecord(client, szPlayerName);
	}
	return Plugin_Handled;
}


public Action:Admin_ResetBhopRecords(client, args)
{
	if(args == 1)
	{
		decl String:szPlayerName[MAX_NAME_LENGTH];
		GetCmdArg(1, szPlayerName, MAX_NAME_LENGTH);		
		db_resetPlayerBhopRecord(client, szPlayerName);
	}
	return Plugin_Handled;
}

public Action:Admin_ResetMultiBhopRecords(client, args)
{
	if(args == 1)
	{
		decl String:szPlayerName[MAX_NAME_LENGTH];
		GetCmdArg(1, szPlayerName, MAX_NAME_LENGTH);		
		db_resetPlayerMultiBhopRecord(client, szPlayerName);
	}
	return Plugin_Handled;
}